<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8" />
    <title>Jenis Karyawan API</title>

    <link rel="stylesheet" href="/css/bootstrap.min.css">

</head>

<body class="bg-light">
    <nav class="navbar navbar-expand-lg navbar-light bg-white border-bottom">
        <a class="navbar-brand" href="#">Cuti</a>
    </nav>
    <div class="container-fluid">
        <div class="row" style="min-height: 93.8vh">
            <div class="col-md-2 bg-white shadow">
                <div class="list-group mt-3">
                    <a href="/jenis_cuti/index" class="list-group-item list-group-item-action ">Jenis Cuti</a>
                    <a href="/jenis_karyawan/index" class="list-group-item list-group-item-action active">Jenis Karyawan</a>
                    <a href="/karyawan/index" class="list-group-item list-group-item-action ">Karyawan</a>
                    <a href="/status/index" class="list-group-item list-group-item-action">Status</a>
                    <a href="/cuti/index" class="list-group-item list-group-item-action">Cuti</a>
                    <a href="/cuti_approval/index" class="list-group-item list-group-item-action">Cuti Approval</a>
                </div>
            </div>
            <div class="col-md-10">
                <div class="card mt-3">
                    <div class="card-body shadow">
                        <h2>Jenis Karyawan API</h2>
                        <p>
                            <button class="btn btn-primary" onclick="OpenList(0, 5)">Open List</button>
                            <button class="btn btn-primary" onclick="OpenForm()">Open Add Form</button>
                        </p>
                        <input class="form-control" type="text" placeholder="Search" onkeyup="SearchJenisKaryawan(this.value)" autocomplete="off">
                        <div id="jenisKaryawanList"></div>
                    </div>
                </div>
            </div>
        </div>
    </div>
    <script src="/js/jquery-3.5.1.min.js"></script>
    <script src="/js/bootstrap-bundle.min.js"></script>

    <script>
        function OpenList() {
            $.ajax({
                url: '/api/jenis_karyawan',
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var table = '<table class="table table-hover">';

                    table += "<tr>";
                    table += "<th> # </th>";
                    table += "<th> Jenis Karyawan </th>";
                    table += "<th> Keterangan </th>";
                    table += "<th> Action</th>";
                    table += "</tr>";

                    for (let i = 0; i < data.length; i++) {
                        table += "<tr>";
                        table += "<td>" + (i + 1) + "</td>";
                        table += "<td>" + data[i].nama + "</td>";
                        table += "<td>" + data[i].keterangan + "</td>";
                        table += "<td><button class='btn btn-success' value='" + data[i].id + "' onclick='formEdit(this.value)'>Update</button> " + ' '
                        table += "<button class='btn btn-danger' value='" + data[i].id + "' onclick='formDelete(this.value)'>Delete</button></td>";
                        table += "</tr>"
                    }
                    table += "</table>";
                    $('#jenisKaryawanList').html(table);
                }
            });
        }

        function OpenForm() {
            var form = '<table class="table table-bordered"';
            form += "<tr>";
            form += "<td>Nama Jenis</td>";
            form += '<td><input class="form-control" type ="text" id="nama"></td>';
            form += "</tr>";
            form += "<tr>";
            form += "<td>Keterangan</td>";
            form += '<td><input class="form-control" type ="text" id="keterangan"></td>';
            form += "</tr>";
            form += "<tr>";
            form += '<td colspan="2"><button class="btn btn-primary" onclick = "SaveJenisKaryawan(this.value)">Save</button></td>';
            form += '</tr>';
            $("#jenisKaryawanList").html(form);
        }

        function SaveJenisKaryawan() {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"keterangan":"' + $('#keterangan').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/jenis_karyawan',
                type: 'post',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList(0, 5);
                }
            });
        }

        function formEdit(id) {
            $.ajax({
                url: '/api/jenis_karyawan/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    form += "<td>Nama Jenis</td>";
                    form += '<td><input class="form-control" type ="text" id="nama" value="' + data.nama + '"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Keterangan</td>";
                    form += '<td><input class="form-control" type="text" id="keterangan" value="' + data.keterangan + '"></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_on" value="' + data.createdOn + '"></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_by" value="' + data.createdBy + '"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-primary" value="' + data.id + '" onclick="UpdateJenisKaryawan(this.value)">Save</button></td>';
                    form += '</tr>';
                    $('#jenisKaryawanList').html(form);
                }
            })
        }

        function UpdateJenisKaryawan(id) {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"keterangan":"' + $('#keterangan').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/jenis_karyawan/' + id,
                type: 'put',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }

        function formDelete(id) {
            $.ajax({
                url: '/api/jenis_karyawan/' + id,
                type: 'get',
                contentType: 'application/json',
                success: function(data) {
                    var form = '<table class="table table-bordered">';
                    form += "<tr>";
                    form += "<td>Nama Jenis</td>";
                    form += '<td><input class="form-control" type ="text" id="nama" value="' + data.nama + '" disabled></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += "<td>Keterangan</td>";
                    form += '<td><input class="form-control" type="text" id="keterangan" value="' + data.keterangan + '" disabled></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_on" value="' + data.createdOn + '"></td>';
                    form += '<td><input class="form-control" type="hidden" id="created_by" value="' + data.createdBy + '"></td>';
                    form += "</tr>";
                    form += "<tr>";
                    form += '<td colspan="2"><button class="btn btn-danger" value="' + data.id + '" onclick="DeleteJenisKaryawan(this.value)">Delete</button></td>';
                    form += '</tr>';
                    $('#jenisKaryawanList').html(form);
                }
            })
        }

        function DeleteJenisKaryawan(id) {
            var formData = '{';
            formData += '"nama":"' + $('#nama').val() + '",';
            formData += '"keterangan":"' + $('#keterangan').val() + '"';
            formData += '}';

            $.ajax({
                url: '/api/jenis_karyawan/' + id,
                type: 'delete',
                contentType: 'application/json',
                data: formData,
                success: function(data) {
                    OpenList();
                }
            });
        }
    </script>